<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Download, 7.8 of March 30, 2011 on December 7, 2011 at 11:52:11 AM</time-stamp>


<component-created>
<name>CS535Adventure</name> <type>package</type>
</component-created><!-- Package CS535Adventure* -->


<component-property>
<name>CS535Adventure</name> <type>package</type>
<property>packageName</property> <value>'CS535Adventure'</value>
</component-property>

<name-space>
<name>Adventure</name>
<environment>Smalltalk</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			</imports>
<category>CS535Adventure</category>
<attributes>
<package>CS535Adventure</package>
</attributes>
</name-space>

<class>
<name>Door</name>
<environment>Adventure</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>label1 label2 space1 space2 </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>CS535Adventure</package>
</attributes>
</class>

<class>
<name>MazeBuilder</name>
<environment>Adventure</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>input maze </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>CS535Adventure</package>
</attributes>
</class>

<class>
<name>Maze</name>
<environment>Adventure</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>rooms doors </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>CS535Adventure</package>
</attributes>
</class>

<class>
<name>Room</name>
<environment>Adventure</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name width height doors </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>CS535Adventure</package>
</attributes>
</class>

<methods>
<class-id>Adventure.Door class</class-id> <category>instance creation</category>

<body package="CS535Adventure" selector="label:space:label:space:">label: labelString1 space: firstSpace label: labelString2 space: secondSpace

	^self new
		setLabel: labelString1
		space: firstSpace
		label: labelString2
		space: secondSpace</body>
</methods>


<methods>
<class-id>Adventure.Door</class-id> <category>accessing</category>

<body package="CS535Adventure" selector="setLabel:space:label:space:">setLabel: labelString1 space: firstSpace label: labelString2 space: secondSpace

	label1 := labelString1.
	label2 := labelString2.
	space1 := firstSpace.
	space2 := secondSpace.
	space1 addDoor: self.
	space2 addDoor: self.</body>
</methods>

<methods>
<class-id>Adventure.Door</class-id> <category>printing</category>

<body package="CS535Adventure" selector="printOn:">printOn: aStream

	aStream
		nextPutAll: 'Door';
		space;
		nextPutAll: label1;
		nextPut: $-;
		nextPutAll: label2</body>
</methods>


<methods>
<class-id>Adventure.MazeBuilder class</class-id> <category>configurationFile</category>

<body package="CS535Adventure" selector="configurationFileReadStream">configurationFileReadStream

	self ensureFileExists.
	^self configurationFile asFilename readStream</body>

<body package="CS535Adventure" selector="ensureFileExists">ensureFileExists

	| configurationFile output |
	configurationFile := self configurationFile asFilename.
	configurationFile exists
		ifFalse: 
			[output := configurationFile writeStream.
			output nextPutAll: self sampleConfigurationFile.
			output close. ]</body>

<body package="CS535Adventure" selector="sampleConfigurationFile">sampleConfigurationFile
	^'Room
	label: A
	width: 10
	height: 5
Room
	label: B
	width: 8
	height: 5
Door
	label: z space: A
	label: x space: B'</body>

<body package="CS535Adventure" selector="configurationFile">configurationFile
	^'data.txt'</body>
</methods>

<methods>
<class-id>Adventure.MazeBuilder class</class-id> <category>instance creation</category>

<body package="CS535Adventure" selector="new">new
	"Answer a newly created and initialized instance."

	^super new initialize</body>
</methods>


<methods>
<class-id>Adventure.MazeBuilder</class-id> <category>building</category>

<body package="CS535Adventure" selector="createRoom:width:height:">createRoom: label width: width height: height

	| aRoom |
	aRoom := Room name: label width: width height: height.
	maze addRoom: aRoom.</body>

<body package="CS535Adventure" selector="createDoorLabel:space:label:space:">createDoorLabel: label1 space: space1 label: label2 space: space2

	| firstSpace secondSpace aDoor |
	firstSpace := maze spaceNamed: space1.
	secondSpace := maze spaceNamed: space2.
	aDoor := Door
				label: label1
				space: firstSpace
				label: label2
				space: secondSpace.
	maze addDoor: aDoor</body>
</methods>

<methods>
<class-id>Adventure.MazeBuilder</class-id> <category>accessing</category>

<body package="CS535Adventure" selector="maze">maze

	^maze</body>
</methods>

<methods>
<class-id>Adventure.MazeBuilder</class-id> <category>parsing</category>

<body package="CS535Adventure" selector="createMaze">createMaze

	| type |
	input := self class configurationFileReadStream.
	
	[[input atEnd] whileFalse: 
			[type := self nextLine asLowercase.
			type = 'room' ifTrue: [self createRoom].
			type = 'door' ifTrue: [self createDoor].
			type = 'corridor' ifTrue: [self createCorridor]]]
			ensure: [input close].
	^maze</body>

<body package="CS535Adventure" selector="createRoom">createRoom

	| label width height line tokens key value |

	3 timesRepeat: [
		line := self nextLine.
		tokens := line tokensBasedOn: $:.
		key := tokens first trimWhitespace asLowercase.
		value := tokens last trimWhitespace.
		(key = 'label') ifTrue: [label := value].
		(key = 'width') ifTrue: [width := value].
		(key = 'height') ifTrue: [height := value]].
	self createRoom: label width: width height: height.</body>

<body package="CS535Adventure" selector="createDoor">createDoor

	| label1 label2 space1 space2 line tokens |
	line := self nextLine.
	tokens := line tokensBasedOn: Character space.
	label1 := (tokens at: 2) trimWhitespace.
	space1 := tokens last trimWhitespace.
	line := input nextLine trimBlanks.
	tokens := line tokensBasedOn: Character space.
	label2 := (tokens at: 2) trimWhitespace.
	space2 := tokens last trimWhitespace.
	self
		createDoorLabel: label1
		space: space1
		label: label2
		space: space2</body>

<body package="CS535Adventure" selector="nextLine">nextLine

	^input nextLine trimBlanks</body>
</methods>

<methods>
<class-id>Adventure.MazeBuilder</class-id> <category>initialize-release</category>

<body package="CS535Adventure" selector="initialize">initialize

	super initialize.	
	maze := Maze new.</body>
</methods>


<methods>
<class-id>Adventure.Maze class</class-id> <category>instance creation</category>

<body package="CS535Adventure" selector="new">new
	"Answer a newly created and initialized instance."

	^super new initialize</body>
</methods>


<methods>
<class-id>Adventure.Maze</class-id> <category>accessing</category>

<body package="CS535Adventure" selector="spaceNamed:">spaceNamed: aString

	^rooms detect: [:each | each hasName: aString]</body>
</methods>

<methods>
<class-id>Adventure.Maze</class-id> <category>adding</category>

<body package="CS535Adventure" selector="addRoom:">addRoom: aRoom

	rooms add: aRoom</body>

<body package="CS535Adventure" selector="addDoor:">addDoor: aDoor

	doors add: aDoor</body>
</methods>

<methods>
<class-id>Adventure.Maze</class-id> <category>initialize-release</category>

<body package="CS535Adventure" selector="initialize">initialize
	
	rooms := OrderedCollection new.
	doors := OrderedCollection new.</body>
</methods>


<methods>
<class-id>Adventure.Room class</class-id> <category>instance creation</category>

<body package="CS535Adventure" selector="name:width:height:">name: label width: width height: height
	^self new setName: label width: width height: height</body>
</methods>


<methods>
<class-id>Adventure.Room</class-id> <category>accessing</category>

<body package="CS535Adventure" selector="addDoor:">addDoor: aDoor
	
	doors add: aDoor</body>
</methods>

<methods>
<class-id>Adventure.Room</class-id> <category>printing</category>

<body package="CS535Adventure" selector="printOn:">printOn: aStream

	aStream
		nextPutAll: 'Room';
		space;
		nextPutAll: name</body>
</methods>

<methods>
<class-id>Adventure.Room</class-id> <category>testing</category>

<body package="CS535Adventure" selector="hasName:">hasName: aString

	^name = aString</body>
</methods>

<methods>
<class-id>Adventure.Room</class-id> <category>initialize-release</category>

<body package="CS535Adventure" selector="setName:width:height:">setName: label width: widthString height: heightString

	name := label.
	width := widthString.
	height := heightString.
	doors := OrderedCollection new.</body>
</methods>


<methods>
<class-id>Core.CharacterArray</class-id> <category>converting</category>

<body package="CS535Adventure" selector="trimWhitespace">trimWhitespace

	| size index |
	(size := self size) == 0 ifTrue:
		[^self species new: 0].
	index := 1.
	[(self at: index) isSeparator] whileTrue:
		[index == size ifTrue:
			[^self species new: 0].
		 index := index + 1].
	[(self at: size) isSeparator] whileTrue:
		[index == size ifTrue:
			[^self species new: 0].
		 size := size - 1].
	^self copyFrom: index to: size</body>
</methods>


<methods>
<class-id>Core.Stream</class-id> <category>accessing</category>

<body package="CS535Adventure" selector="nextLine">nextLine
	^self upTo: Character cr.</body>
</methods>



</st-source>
